rm(list=ls())
#
quantileknots=function(x,nknots,boundstab=0){
  
  x = unique(x) ;
  n = length(x) ;
  xsort = sort(x) ;   
  loc = n*((1:nknots)+2*boundstab)/ (nknots+1+2*boundstab)
  knots=xsort[round(loc)] ;
  knots=knots[(1 + boundstab) : (nknots + boundstab)] ;  
}

basis_fun=function(x,degree,knots,der=0){
  if(der > degree){
    stop("WARNING:  der > degree --- xm not returned by powerbasis")
  }
  n=length(x);
  nknots = length(knots);
  if(der == 0){
    xm=rep(1,n);
  }
  else{
    xm = rep(0,n);
  }
  
  for(i in 1:degree){
    if(i < der){
      xm = cbind(xm,rep(0,n))
    }
    else{
      if((i-der+1)<=i){
        xm = cbind(xm,prod((i-der+1):i)*x^(i-der))
      }
      else{
        xm = cbind(xm,x^(i-der))
      }
    }
  }
  
  if(nknots > 0){
    for(i in 1:(nknots)){
      if((degree-der+1)<=degree){
        xm = cbind(xm,prod((degree-der+1):degree) * (x-knots[i])^(degree-der)*(x > knots[i])) ;
      }
      else{
        xm = cbind(xm,(x-knots[i])^(degree-der)*(x > knots[i])) ;
      }
    }
  }
  return(xm)
}

#򵥵
# n=600;
# t=runif(n,0,1)
# nknots=5;
# degree=4;
# knots = quantileknots(t,nknots);
# xm=basis_fun(t,degree,knots);
# Y=sin(2*pi*t)+rnorm(n,0,1);
# 
# Beta=solve(t(xm)%*%xm)%*%t(xm)%*%Y;
# plot(t,sin(2*pi*t))
# lines(t,xm%*%Beta,col="red",type="p")
# num=61
data=read.csv("Others.csv",header = T)
data=data[-(1:176),]
num=nrow(data)/16-1
Yi=c(data[17:32,2]-data[1:16,2])
for(i in 2:num){
  Yi=c(Yi,data[(1+i*16):((i+1)*16),2]-data[(1+(i-1)*16):(i*16),2])
}
Yi[which(Yi<0)]=0
x=as.matrix(data[-(1:16),c(3,5)])
x[,2]=x[,2]/1000
x=x[1:(num*16),]
Ui=seq(1,num)
nknots=c(2,2)
degree=c(2,6)
#Եһϵȡ
nknots1=nknots[1]
degree1=degree[1]
knots1 = quantileknots(Ui,nknots1)
xm1=basis_fun(Ui,degree1,knots1)
x1=array(0,dim=c(nrow(x),ncol(xm1)))
for(i in 1:num){
  x1[(1+(i-1)*16):(i*16),]=matrix(x[(1+(i-1)*16):(i*16),1],ncol=1)%*%xm1[i,]
}
L1=ncol(x1)
#Եڶϵȡ
nknots2=nknots[2]
degree2=degree[2]
knots2 = quantileknots(Ui,nknots2)
xm2=basis_fun(Ui,degree2,knots2)
x2=array(0,dim=c(nrow(x),ncol(xm2)))
for(i in 1:num){
  x2[(1+(i-1)*16):(i*16),]=matrix(x[(1+(i-1)*16):(i*16),2],ncol=1)%*%xm2[i,]
}
L2=ncol(x2)

#ȨСϵ
W=cbind(x1,x2)
summ=glm(Yi~W,family=quasi(variance="mu",link="log"))
#summ=glm(Yi~W,family="poisson")
hatgam1=summ[[1]][2:(1+L1)]
hatgam2=summ[[1]][(1+L1+1):(1+L1+L2)]


hatbeta1Ui=xm1%*%hatgam1
hatbeta2Ui=xm2%*%hatgam2
# hatbeta3Ui=xm3%*%hatgam3
# hatbeta4=summ[[1]][1+L1+L2+L3+1]

par(mfrow=c(1,3))
plot(Ui,hatbeta1Ui,type="l",col=1,xlab="u",ylab="beta(u)",lwd=2)
plot(Ui,hatbeta2Ui,type="l",col=1,xlab="u",ylab="beta(u)",lwd=2)
# plot(Ui,hatbeta3Ui,type="l",col=1,xlab="u",ylab="beta(u)",lwd=2)
# plot(Ui,rep(hatbeta4,num),type="l",col=1,xlab="u",ylab="beta(u)",lwd=2)
#plot(Ui,rep(hatbeta5,num),type="l",col=1,xlab="u",ylab="beta(u)",lwd=2)

#еϵƾֵ
lambda=numeric(num*16)
for(i in 1:num){
  lambda[(1+(i-1)*16):(i*16)]=exp(summ[[1]][[1]]+x[(1+(i-1)*16):(i*16),1]*hatbeta1Ui[i]+x[(1+(i-1)*16):(i*16),2]*hatbeta2Ui[i])
}
lambda_mean=numeric(num)
Yi_mean=numeric(num)
for(i in 1:num){
  lambda_mean[i]=mean(lambda[(1+(i-1)*16):(i*16)])
  Yi_mean[i]=mean(Yi[(1+(i-1)*16):(i*16)])
}
plot(Ui,Yi_mean,'l',col=1)
lines(Ui,lambda_mean,type="l",col=2,lwd=1)

#mA
Y0=mean(data[(1:16),2])
aclambda=cumsum(c(Y0,lambda_mean))
acYi=numeric(num+1)
for(i in 1:(num+1)){
  acYi[i]=mean(data[(1+(i-1)*16):(i*16),2])
}
plot(1:(num+1),acYi,col=1)
lines(1:(num+1),aclambda,type="o",pch=2,col=2,lwd=1)
aclambda=aclambda[-1]

M=seq(1,30)
A=seq(30,5000,10)
#Y=data[2:(num+1),1]
Mat=array(0,dim=c(length(A),length(M)))
k=1;
for(a in A){
  for(m in M){
    V=numeric(num-m+1)
    #һַĳֵ2050m=14
    V[1]=lambda_mean[1]+a
    for(j in 2:length(V)){
      #W[j]=W[j-1]+lambda[j+m-1]+lambda[j-1]
      V[j]=V[j-1]+lambda_mean[j+m-1]
    }
    Mat[k,m]=mean((aclambda[m:num]-V)^2)
  }
  k=k+1;
}

# lambda[1]
mean((Yi_mean-lambda_mean)^2)


inds = which(Mat == min(Mat), arr.ind=TRUE)
a=A[inds[,1]]
m=M[inds[,2]]
a
m
Mat[inds]


V=numeric(num-m+1)
V[1]=lambda_mean[1]+a
for(j in 2:length(V)){
  #W[j]=W[j-1]+lambda[j+m-1]+lambda[j-1]
  V[j]=V[j-1]+lambda_mean[j+m-1]
}


#gamma ʵλǴm+1쿪ʼT-m
gamma=numeric(num-m-(m+1)+1)
for(i in (m+1+1):(num-m+1)){
  if((V[i-1]-V[i-1-m])!=0){
    gamma[i-(m+1)]=(V[i]-V[i-1])/(V[i-1]-V[i-1-m])
  }
  else
    gamma[i-(m+1)]=0
}


#˺
kern=function(u,method="gaussian"){
  if(method=="gaussian"){
    K=exp(-(1/2)*u^2)/sqrt(2*pi)
  }
  if(method=='Ep'){
    K=3/4*(1-u^2)*ifelse(abs(u)<=1,1,0)
  }
  if(method=="quartic"){
    K=15/16*(1-u^2)*ifelse(abs(u)<=1,1,0)
  }
  return(K)
}

n=length(gamma)
X=seq(1,n)
gamhat=NULL
MSE=NULL
h=1.5
for (i in (1:n)){
  gamhat[i]=sum(gamma*exp(-(X-X[i])^2/(2*h^2)))/sum(exp(-(X-X[i])^2/(2*h^2)))
}
plot(X,gamma,'l',xlim=c(0,n),ylim=c(0,max(gamma))) 
par(new=TRUE)
plot(X,gamhat,'l',xlim=c(0,n),ylim=c(0,max(gamma)),
     ann=F,col='red') 


T=seq(m+1,num-m)
temp <- as.character(seq.Date(from = as.Date("2020/01/28"), by = "day", length.out = 56))
plot(T,gamhat,type='o',xaxt='n',xlab='')
axis(1,at=T,label=temp[T],las=3,cex.axis = 0.7,font.axis=10)
hatR=m*gamhat
plot(T,type='o',hatR,xaxt='n',xlab='')
axis(1,at=T,label=temp[T],las=3,cex.axis = 0.7,font.axis=10)
# T
# hatR1=m*log(lambda[(m+2):(num-m+1)]/lambda[(m+1):(num-m)])+1
# plot(T,type='o',hatR1,xaxt='n',xlab='')
# axis(1,at=T,label=temp[T],las=3,cex.axis = 0.7,font.axis=10)


#
#ϵ
#ԹƳϵΪ׼ٴӲɷֲвYȥϵظ100
rept=100
beta0_low=beta0_upper=0
beta1_low=numeric(num)
beta1_upper=numeric(num)
beta2_low=numeric(num)
beta2_upper=numeric(num)
interval0=numeric(rept)
interval1=array(0,dim=c(rept,num)) 
interval2=array(0,dim=c(rept,num)) 
intervalgam=array(0,dim=c(rept,num-m-(m+1)+1)) 
for(k in 1:rept){
  hatlmda=lambda
  new_Yi=rpois(num*16,hatlmda)
  new_summ=glm(new_Yi~W,family=quasi(variance="mu",link="log"))
  new_hatgam1=new_summ[[1]][2:(1+L1)]
  new_hatgam2=new_summ[[1]][(1+L1+1):(1+L1+L2)]
  new_hatbeta1Ui=xm1%*%new_hatgam1
  new_hatbeta2Ui=xm2%*%new_hatgam2
  interval0[k]=new_summ[[1]][[1]]
  interval1[k,]=new_hatbeta1Ui
  interval2[k,]=new_hatbeta2Ui
  #еϵƾֵ
  new_lambda=numeric(num*16)
  for(i in 1:num){
    new_lambda[(1+(i-1)*16):(i*16)]=exp(new_summ[[1]][[1]]+x[(1+(i-1)*16):(i*16),1]*new_hatbeta1Ui[i]+x[(1+(i-1)*16):(i*16),2]*new_hatbeta2Ui[i])
  }
  new_lambda_mean=numeric(num)
  for(i in 1:num){
    new_lambda_mean[i]=mean(new_lambda[(1+(i-1)*16):(i*16)])
  }
  new_V=numeric(num-m+1)
  new_V[1]=new_lambda_mean[1]+a
  for(j in 2:length(new_V)){
    #W[j]=W[j-1]+lambda[j+m-1]+lambda[j-1]
    new_V[j]=new_V[j-1]+new_lambda_mean[j+m-1]
  }
  #gamma ʵλǴm+1쿪ʼT-m
  new_gamma=numeric(num-m-(m+1)+1)
  for(i in (m+1+1):(num-m+1)){
    if((new_V[i-1]-new_V[i-1-m])!=0){
      new_gamma[i-(m+1)]=(new_V[i]-new_V[i-1])/(new_V[i-1]-new_V[i-1-m])
    }
    else
      new_gamma[i-(m+1)]=0
  }
  intervalgam[k,]=new_gamma
}
beta0_low=sort(interval0)[rept*0.025]
beta0_upper=sort(interval0)[rept*0.975]
for(i in 1:num){
  beta1_low[i]=sort(interval1[,i])[rept*0.025]
  beta1_upper[i]=sort(interval1[,i])[rept*0.975]
  beta2_low[i]=sort(interval2[,i])[rept*0.025]
  beta2_upper[i]=sort(interval2[,i])[rept*0.975]
}
gamma_low=gamma_upper=numeric(num-m-(m+1)+1)
for(i in 1:(num-m-(m+1)+1)){
  gamma_low[i]=sort(intervalgam[,i])[rept*0.025]
  gamma_upper[i]=sort(intervalgam[,i])[rept*0.975]
}

plot(Ui,hatbeta1Ui,type="l",col=1,xlab="u",ylab="beta(u)",lwd=2)
lines(Ui,beta1_low,lty=4,col=1,lwd=2)
lines(Ui,beta1_upper,lty=4,col=1,lwd=2)  

# plot(Ui[1:35],hatbeta1Ui[1:35],type="l",col=1,xlab="u",ylab="beta(u)",lwd=2)
# lines(Ui[1:35],beta1_low[1:30],lty=4,col=1,lwd=2)
# lines(Ui[1:35],beta1_upper[1:35],lty=4,col=1,lwd=2)  
# 
# plot(Ui[36:num],hatbeta1Ui[36:num],type="l",col=1,xlab="u",ylab="beta(u)",lwd=2)
# lines(Ui[36:num],beta1_low[36:num],lty=4,col=1,lwd=2)
# lines(Ui[36:num],beta1_upper[36:num],lty=4,col=1,lwd=2)  


plot(Ui,hatbeta2Ui,type="l",col=1,xlab="u",ylab="beta(u)",lwd=2)
lines(Ui,beta2_low,lty=4,col=1,lwd=2)
lines(Ui,beta2_upper,lty=4,col=1,lwd=2)  


plot(Ui[1:35],hatbeta2Ui[1:35],type="l",col=1,xlab="u",ylab="beta(u)",lwd=2)
lines(Ui[1:35],beta2_low[1:35],lty=4,col=1,lwd=2)
lines(Ui[1:35],beta2_upper[1:35],lty=4,col=1,lwd=2)  

plot(Ui[36:40],hatbeta2Ui[36:40],type="l",col=1,xlab="u",ylab="beta(u)",lwd=2)
lines(Ui[36:40],beta2_low[36:40],lty=4,col=1,lwd=2)
lines(Ui[36:40],beta2_upper[36:40],lty=4,col=1,lwd=2) 

plot(Ui[41:num],hatbeta2Ui[41:num],type="l",col=1,xlab="u",ylab="beta(u)",lwd=2)
lines(Ui[41:num],beta2_low[41:num],lty=4,col=1,lwd=2)
lines(Ui[41:num],beta2_upper[41:num],lty=4,col=1,lwd=2)  

T=seq(m+1,num-m)
temp <- as.character(seq.Date(from = as.Date("2020/01/28"), by = "day", length.out = 56))
plot(T,gamma,type='o',xaxt='n',xlab='')
axis(1,at=T,label=temp[T],las=3,cex.axis = 0.7,font.axis=10)
lines(T,gamma_low,lty=4,col=1,lwd=2)
lines(T,gamma_upper,lty=4,col=1,lwd=2)  

#⻬
new_n=length(gamma_low)
X=seq(1,new_n)
new_gamhat_low=NULL
new_gamhat_upper=NULL
new_MSE=NULL
for (i in (1:new_n)){
  new_gamhat_low[i]=sum(gamma_low*exp(-(X-X[i])^2/(2*h^2)))/sum(exp(-(X-X[i])^2/(2*h^2)))
  new_gamhat_upper[i]=sum(gamma_upper*exp(-(X-X[i])^2/(2*h^2)))/sum(exp(-(X-X[i])^2/(2*h^2)))
}

#par(new=TRUE)
T=seq(m+1,num-m)
temp <- as.character(seq.Date(from = as.Date("2020/01/28"), by = "day", length.out = 56))
plot(T,gamhat,type='o',xaxt='n',xlab='')
axis(1,at=T,label=temp[T],las=3,cex.axis = 0.7,font.axis=10)
lines(T,new_gamhat_low,lty=4,col=1,lwd=2)
lines(T,new_gamhat_upper,lty=4,col=1,lwd=2)  

plot(T,gamhat,type="l",ylim=c(min(new_gamhat_low),max(new_gamhat_upper)),lty=1,col=1,xaxt='n',xlab="",ylab="Gamma_Kt",lwd=1)
par(new=TRUE)
plot(T,new_gamhat_low,type="l",ylim=c(min(new_gamhat_low),max(new_gamhat_upper)),lty=3,col=2,xaxt='n',xlab="",ylab="",lwd=1)
par(new=TRUE)
plot(T,new_gamhat_upper,type="l",ylim=c(min(new_gamhat_low),max(new_gamhat_upper)),lty=3,col=2,xaxt='n',xlab="",ylab="",lwd=1)
axis(1,at=T,label=temp[T],las=3,cex.axis = 0.8,font.axis=10)




# #۲ÿʱͼ
# #人Դ
# whfrom=numeric(num)
# for(i in 2:(num-1)){
#   whfrom[i-1]=mean(data[(1+(i-1)*16):(i*16),3])
# }
# plot(Ui,whfrom)
# 
# #ʱ
# hetime=numeric(num)
# for(i in 2:(num-1)){
#   hetime[i-1]=mean(data[(1+(i-1)*16):(i*16),4])
# }
# plot(Ui,hetime)
# 
# #ҽԱ
# person=numeric(num)
# for(i in 2:(num-1)){
#   person[i-1]=mean(data[(1+(i-1)*16):(i*16),5])
# }
# plot(Ui,person)
