basis_fun=function(x,degree,knots,der=0){
  if(der > degree){
    stop("WARNING:  der > degree --- xm not returned by powerbasis")
  }
  n=length(x);
  nknots = length(knots);
  if(der == 0){
    xm=rep(1,n);
  }
  else{
    xm = rep(0,n);
  }
  
  for(i in 1:degree){
    if(i < der){
      xm = cbind(xm,rep(0,n))
    }
    else{
      if((i-der+1)<=i){
        xm = cbind(xm,prod((i-der+1):i)*x^(i-der))
      }
      else{
        xm = cbind(xm,x^(i-der))
      }
    }
  }
  
  if(nknots > 0){
    for(i in 1:(nknots)){
      if((degree-der+1)<=degree){
        xm = cbind(xm,prod((degree-der+1):degree) * (x-knots[i])^(degree-der)*(x > knots[i])) ;
      }
      else{
        xm = cbind(xm,(x-knots[i])^(degree-der)*(x > knots[i])) ;
      }
    }
  }
  return(xm)
}