rm(list=ls())
#
quantileknots=function(x,nknots,boundstab=0){
  
  x = unique(x) ;
  n = length(x) ;
  xsort = sort(x) ;   
  loc = n*((1:nknots)+2*boundstab)/ (nknots+1+2*boundstab)
  knots=xsort[round(loc)] ;
  knots=knots[(1 + boundstab) : (nknots + boundstab)] ;  
}

basis_fun=function(x,degree,knots,der=0){
  if(der > degree){
    stop("WARNING:  der > degree --- xm not returned by powerbasis")
  }
  n=length(x);
  nknots = length(knots);
  if(der == 0){
    xm=rep(1,n);
  }
  else{
    xm = rep(0,n);
  }
  
  for(i in 1:degree){
    if(i < der){
      xm = cbind(xm,rep(0,n))
    }
    else{
      if((i-der+1)<=i){
        xm = cbind(xm,prod((i-der+1):i)*x^(i-der))
      }
      else{
        xm = cbind(xm,x^(i-der))
      }
    }
  }

  if(nknots > 0){
    for(i in 1:(nknots)){
      if((degree-der+1)<=degree){
        xm = cbind(xm,prod((degree-der+1):degree) * (x-knots[i])^(degree-der)*(x > knots[i])) ;
      }
      else{
        xm = cbind(xm,(x-knots[i])^(degree-der)*(x > knots[i])) ;
      }
    }
  }
  return(xm)
}

#򵥵
# n=600;
# t=runif(n,0,1)
# nknots=5;
# degree=4;
# knots = quantileknots(t,nknots);
# xm=basis_fun(t,degree,knots);
# Y=sin(2*pi*t)+rnorm(n,0,1);
# 
# Beta=solve(t(xm)%*%xm)%*%t(xm)%*%Y;
# plot(t,sin(2*pi*t))
# lines(t,xm%*%Beta,col="red",type="p")


num=55
data=read.csv("wuhan.csv",header = T)
Yi=diff(data[,1])
x=as.matrix(data[-1,2:6])
x[,1]=x[,1]/10000
x[,3]=x[,3]/10000
Yi=Yi[1:num]
x=x[1:num,]
n=length(Yi)
Ui=seq(1,num)
nknots=c(2,4,3)
degree=c(2,5,4)
#Եһϵȡ
nknots1=nknots[1]
degree1=degree[1]
knots1 = quantileknots(Ui,nknots1)
xm1=basis_fun(Ui,degree1,knots1)
x1=xm1*x[,1]
L1=ncol(x1)
#Եڶϵȡ
nknots2=nknots[2]
degree2=degree[2]
knots2 = quantileknots(Ui,nknots2)
xm2=basis_fun(Ui,degree2,knots2)
x2=xm2*x[,2]
L2=ncol(x2)
#Եϵȡ
nknots3=nknots[3]
degree3=degree[3]
knots3 = quantileknots(Ui,nknots3)
xm3=basis_fun(Ui,degree3,knots3)
x3=xm3*x[,3]
L3=ncol(x3)
#ȨСϵ
W=cbind(x1,x2,x3,x[,4],x[,5])
summ=glm(Yi~W,family=quasi(variance="mu",link="log"))


hatgam1=summ[[1]][2:(1+L1)]
hatgam2=summ[[1]][(1+L1+1):(1+L1+L2)]
hatgam3=summ[[1]][(1+L1+L2+1):(1+L1+L2+L3)]

hatbeta1Ui=xm1%*%hatgam1
hatbeta2Ui=xm2%*%hatgam2
hatbeta3Ui=xm3%*%hatgam3
hatbeta4=summ[[1]][1+L1+L2+L3+1]
hatbeta5=summ[[1]][1+L1+L2+L3+2]
#еϵƾֵ
lambda=numeric(n)
for(i in 1:n){
  lambda[i]=exp(summ[[1]][1]+x[i,1]*hatbeta1Ui[i]+x[i,2]*hatbeta2Ui[i]+x[i,3]*hatbeta3Ui[i]+x[i,4]*hatbeta4+x[i,5]*hatbeta5)
}
write.csv(lambda,'lamhat.csv')
mean((Yi-lambda)^2)
par(mfrow=c(2,2))
plot(Ui,Yi,'l',col=1,xlim=c(min(Ui),max(Ui)),ylim=c(min(Yi),max(Yi)))
par(new=TRUE)
plot(Ui,lambda,type="l",pch=2,col=2,xlim=c(min(Ui),max(Ui)),ylim=c(min(Yi),max(Yi)),lwd=1,ann=F,xaxt='n',xlab='',ylab='')


plot(Ui,hatbeta1Ui,type="l",col=1,xlab="u",ylab="beta1",lwd=2)
plot(Ui,hatbeta2Ui,type="l",col=1,xlab="u",ylab="beta2",lwd=2)
plot(Ui,hatbeta3Ui,type="l",col=1,xlab="u",ylab="beta3",lwd=2)

#-------------m---------------


M=seq(1,30)
A=seq(30,5000,10)
MSE=matrix(0,length(A),length(M))
mstar=NULL
Yt=NULL
Lambda=lambda
for (l in (1:n)){
  Yt[l]=data$Y[1]+sum(Lambda[1:l])
}
for (j in (1:length(A))){
  a=A[j]
  for (i in (1:length(M))){
    Wk=NULL
    Wk0=Lambda[1]+a
    m=M[i]
    print(m)
    for (t in (1:(n-m))){
      Wk[t]=Wk0+sum(Lambda[(m+1):(m+t)])
      # Wk[t]=sum(Lambda[(m+1):(m+t)])+Wk0+sum(Lambda[1:t])
    } 
    Wk=c(Wk0,Wk)
    MSE[j,i]=mean((Yt[m:n]-Wk)^2)
  }
  mstar[j]=which(MSE[j,]==min(MSE[j,]))
}
which(MSE==min(MSE), arr.ind = TRUE)
#A=420,m=8
#Gamma--------------


M=seq(1,50)
a=420
m=8
Lambda=lambda
Wk=NULL
Wk0=Lambda[1]+a
for (t in (1:(n-m))){
  Wk[t]=Wk0+sum(Lambda[(m+1):(m+t)])
  # Wk[t]=sum(Lambda[(m+1):(m+t)])+Wk0+sum(Lambda[1:t])
} 
Wk=c(Wk0,Wk)
Gamma=NULL
T=seq(m+1,n-m)
for (l in (1:length(T))){
  tt=T[l]
  Gamma[l]=(Wk[tt+1]-Wk[tt])/(Wk[tt]-Wk[tt-m])
}
gn=length(Gamma)
Xt=seq(1,gn)
Gamhat=NULL
h=1.3
for (i in (1:gn)){
  Gamhat[i]=sum(Gamma*exp(-(Xt-Xt[i])^2/(2*h^2)))/sum(exp(-(Xt-Xt[i])^2/(2*h^2)))
}
#plot(Xt,Gamma,'l',xlim=c(0,gn),ylim=c(0,max(Gamma))) 
#par(new=TRUE)
#plot(Xt,Gamhat,'l',xlim=c(0,gn),ylim=c(0,max(Gamma)),
     #ann=F,col='red') 
par(mfrow=c(1,2))
temp <- as.character(seq.Date(from = as.Date("2020/01/16"), by = "day", length.out = 56))
plot(T,Gamhat,'l',lty=1,xaxt='n',xlab='',ylab='Gamma')
axis(1,at=T,label=temp[T],las=3,cex.axis = 0.8,font.axis=10)
R=m*Gamhat
yt=expression(R[t])
plot(T,R,'l',lty=1,xaxt='n',xlab='',ylab=yt)
axis(1,at=T,label=temp[T],las=3,cex.axis = 0.8,font.axis=10)
 
write.csv(hatbeta1Ui,'beta1.csv')
write.csv(hatbeta2Ui,'beta2.csv')
write.csv(hatbeta3Ui,'beta3.csv')
write.csv(Gamhat,'Gamhat.csv')
